format   PE native at 0x100000
entry    DriverEntry
include  'win32ax.inc'
include  'equates\wdm32.inc'

;//****** STRING *************
section '.data' data readable writeable notpageable

DevName    du  '\Device\Codeby',0
linkName   du  '\??\Codeby',0
VarName    du  'PsInitialSystemProcess',0

align 16
pDevName   UNICODE_STRING
plinkName  UNICODE_STRING
pVarName   UNICODE_STRING

stopFlag   dd  0
count      dd  0
pDevObj    dd  0
Status     dd  0

;//****** MAIN ***************
section '.text' code readable executable notpageable

proc  DriverEntry, pDrvObject, pRegPath

;//    
       invoke  RtlInitUnicodeString,pDevName,DevName
       invoke  RtlInitUnicodeString,plinkName,linkName
       invoke  RtlInitUnicodeString,pVarName,VarName
      cinvoke  DbgPrint,<'Init string   OK!',0>

;// C . -
       invoke  IoCreateDevice,[pDrvObject],0,pDevName,\
                              FILE_DEVICE_UNKNOWN,\
                              FILE_DEVICE_SECURE_OPEN,0,pDevObj
       or      eax,eax
       je      @f
       mov     [Status],eax
      cinvoke  DbgPrint,<'CreateDevice error:  %08x',0>,eax
       jmp     @exit
@@:   cinvoke  DbgPrint,<'CreateDevice  OK!  %08x',0>,[pDevObj]

;// C   -   
       invoke  IoCreateSymbolicLink,plinkName,pDevName
       or      eax,eax
       je      @f
       mov    [Status],eax
      cinvoke  DbgPrint,<'Create link ERROR! %08x',0>,eax
       jmp     @exit
@@:   cinvoke  DbgPrint,<'Create link   OK!',10,'--------',0>

;//   
       mov     esi,[pDrvObject]
       mov    [esi + DRIVER_OBJECT.DriverUnload] ,CodebyUnload
       mov    [esi + DRIVER_OBJECT.IRP_MJ_CREATE],CodebyCreate
       mov    [esi + DRIVER_OBJECT.IRP_MJ_CLOSE] ,CodebyClose
       mov    [esi + DRIVER_OBJECT.IRP_MJ_DEVICE_CONTROL],CodebyControl

;//   -   Ok
       mov    [Status],STATUS_SUCCESS
@exit: mov    eax,[Status]
       ret
endp

;//********************************************************
;//   -   Dispatch
;//********************************************************
align  16
proc   CodebyUnload, pDrvObject
       invoke  IoDeleteSymbolicLink,plinkName
       invoke  IoDeleteDevice,[pDevObj]
      cinvoke  DbgPrint,<'Unload driver OK!',0>
       mov     eax,STATUS_SUCCESS  ; STATUS_DEVICE_CONFIGURATION_ERROR
       ret
endp
;//----------------
align  16
proc   CodebyCreate,  pDevObj, pIrp
      cinvoke  DbgPrint,<'Dispatch Create! IRP: %08x',10,' ',0>,[pIrp]

       CompleteReq STATUS_SUCCESS,0
       mov     eax,STATUS_SUCCESS
       ret
endp
;//----------------
align  16
proc   CodebyClose,   pDevObj, pIrp
      cinvoke  DbgPrint,<'Dispatch Close!  IRP: %08x',10,'--------',0>,[pIrp]

       CompleteReq STATUS_SUCCESS,0
       mov     eax,STATUS_SUCCESS
       ret
endp
;//----------------
align  16
proc   CodebyControl, pDevObj, pIrp  ; 0x220004
       mov     esi,[pIrp]
       mov     eax,[esi + _IRP.AssociatedIrp]
       push    eax
       mov     ebx,[eax]
       mov     esi,[esi + _IRP.CurrentStackLocation]
       lea     esi,[esi + IO_STACK_LOCATION.Parameters]
      cinvoke  DbgPrint,<'Dispatch IoControl',10,\
                         'IOCTL: 0x%08x  Buff: 0x%08x  BuffSize: %d byte',10,\
                         'InLen: %d byte  Data: 0x%08x',0>,\
                         [esi + PARAM_IO_CONTROL.IoControlCode],eax,\
                         [esi + PARAM_IO_CONTROL.OutputBuffLength],\
                         [esi + PARAM_IO_CONTROL.InputBuffLength],ebx

       invoke  PsGetCurrentProcessId
       xchg    eax,ebx     ;// EBX = Pid  
       invoke  MmGetSystemRoutineAddress,pVarName  ;//<---- PsInitialSystemProcess
       mov     esi,[eax]
       pop     edi         ;// EDI =   IOCTL
       push    edi
       add     edi,4       ;//   dword  - 
@ProcessList:
       push    esi
       mov     eax,[esi + EPROCESS.UniqueProcessId]     ;// 0
       cmp     eax,ebx
       jnz     @f
       inc     [stopFlag]
@@:    stosd
       mov     eax,[esi + EPROCESS.VirtualSize]         ;// 4
       stosd
       mov     eax,[esi + EPROCESS.SectionBaseAddress]  ;// 8
       stosd
       mov     eax,[esi + EPROCESS.ActiveThreads]       ;// 12
       stosd
       mov     eax,esi                                  ;// 16 EPROCESS
       stosd
       mov     eax,[esi + EPROCESS.Peb]                 ;// 20
       stosd
       lea     esi,[esi + EPROCESS.ImageFileName]       ;// 24
       mov     ecx,16
       rep     movsb

       pop     esi
       mov     esi,[esi + EPROCESS.ActiveProcessLinks]
       sub     esi,0x88
       inc     [count]
       cmp     [stopFlag],1
       jnz     @ProcessList

       pop     edi
       mov     eax,[count]
       stosd
      cinvoke  DbgPrint,<'Process count: %d',10,' ',0>,eax

       CompleteReq STATUS_SUCCESS,40*40
       mov     eax,STATUS_SUCCESS
       ret
endp

;//**************************
section '.idata' import data readable writeable
library  ntoskrnl,"ntoskrnl.exe"
include 'api\ntoskrnl.inc'
;//**************************
section '.reloc' data fixups readable discardable



